Get started - Get started with Liveblocks and Solid.js

Liveblocks is a real-time collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Solid.js application using the APIs from the @liveblocks/client package.

Quickstart

  1. Install Liveblocks

    $npm install @liveblocks/client
  2. Set up the client

    The first step in connecting to Liveblocks is creating a client which will be responsible for communicating with the back end.

    const client = createClient({  publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
  3. Join a Liveblocks room

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate. To create a real-time experience, multiple users must be connected to the same room.

    const room = client.enter("my-room", { initialPresence: {} });
  4. Use the Liveblocks methods

    Now that we’re connected to a room, we can start using Liveblocks subscriptions. The first we’ll add is others, a subscription that provides information about which other users are connected to the room.

    import { createSignal, onCleanup, onMount } from "solid-js";import { room } from "./room.js";
    export function Room() { const [other, setOthers] = createSignal(room.getOthers());
    onMount(() => { const unsubscribeOthers = room.subscribe("others", (updatedOthers) => { setOthers(updatedOthers); });
    onCleanup(() => { unsubscribeOthers(); }); })
    return ( <div>There are {others.length} other user(s) online</div> );}
  5. Bonus: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint. This approach is great for prototyping and marketing pages where defining your own security isn’t always required. If you want to implement your own security logic to define if certain users should have access to a given room, you’ll need to implement an authentication endpoint.

    Set up authentication

Next steps

Congratulations! You now have set up the foundation to start building collaborative experiences for your Solid.js application.

Get started - Get started with Liveblocks and React

Liveblocks is a real-time collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the hooks from the @liveblocks/react package.

Quickstart

  1. Install Liveblocks

    $npm install @liveblocks/client @liveblocks/react
  2. Initialize the liveblocks.config.ts file

    $npm create-liveblocks-app@latest --init --react
  3. Set up the client

    The first step in connecting to Liveblocks is creating a client which will be responsible for communicating with the back end. You can do this by modifying createClient in your config file, and passing your public API key.

    const client = createClient({  publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
  4. Join a Liveblocks room

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate. To create a real-time experience, multiple users must be connected to the same room.

    import { RoomProvider } from "./liveblocks.config";import { Room } from "./Room";import { ClientSideSuspense } from "@liveblocks/react";
    export default function App() { return ( <RoomProvider id="my-room" initialPresence={{}}> <ClientSideSuspense fallback={<div>Loading…</div>}> {() => <Room />} </ClientSideSuspense> </RoomProvider> );}
  5. Use the Liveblocks hooks

    Now that we’re connected to a room, we can start using the Liveblocks hooks. The first we’ll add is useOthers, a hook that provides information about which other users are connected to the room.

    import { useOthers } from "./liveblocks.config";        export function Room() {  const others = useOthers();  const userCount = others.length;  return <div>There are {userCount} other user(s) online</div>;}
  6. Bonus: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint. This approach is great for prototyping and marketing pages where defining your own security isn’t always required. If you want to implement your own security logic to define if certain users should have access to a given room, you’ll need to implement an authentication endpoint.

    Set up authentication

Next steps

Congratulations! You now have set up the foundation to start building collaborative experiences for your React application.

Get started - Get started with Liveblocks and Vue.js

Liveblocks is a real-time collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/client package.

Quickstart

  1. Install Liveblocks

    $npm install @liveblocks/client
  2. Set up the client

    The first step in connecting to Liveblocks is creating a client which will be responsible for communicating with the back end.

    const client = createClient({  publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
  3. Join a Liveblocks room

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate. To create a real-time experience, multiple users must be connected to the same room.

    const room = client.enter("my-room", { initialPresence: {} });
  4. Use the Liveblocks methods

    Now that we’re connected to a room, we can start using Liveblocks subscriptions. The first we’ll add is others, a subscription that provides information about which other users are connected to the room.

    <script setup>import { onUnmounted, ref } from "vue";import { room } from "./room.js";
    const others = ref(room.getOthers());
    const unsubscribeOthers = room.subscribe("others", (updatedOthers) => { others.current = updatedOthers;});
    onUnmounted(() => { unsubscribeOthers();});</script>
    <template> <div>There are {{ others.length }} other user(s) online</div></template>
  5. Bonus: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint. This approach is great for prototyping and marketing pages where defining your own security isn’t always required. If you want to implement your own security logic to define if certain users should have access to a given room, you’ll need to implement an authentication endpoint.

    Set up authentication

Next steps

Congratulations! You now have set up the foundation to start building collaborative experiences for your Vue.js application.